#include <avr/io.h>
#include "mmc_hardware.h"

static BYTE on = 0;

void mmc_on(void)
{
	SPI_PORT = (SPI_PORT & ~SPI_SCK) | SPI_SS | SPI_MOSI | SPI_MISO;
	SPI_DDR = (SPI_DDR & ~SPI_MISO) | SPI_SS | SPI_MOSI | SPI_SCK;
	PORTC |= 1;
	DDRC |= 1;

#if !EMULATE_SPI
	SPCR = 0x50; /* Initialize SPI port (Mode 0) */
	SPSR = 0x01;
#endif
	on = 1;
}


void mmc_off()
{
	SPCR = 0;		/* Disable SPI function */
	on = 1;
}

BYTE mmc_is_on(void)
{
	return on;
}

BYTE rcvr_spi (void)
{
#if EMULATE_SPI
	uint8_t i, ret;
	ret = 0;
	SPI_PORT |= SPI_MOSI;
	for (i = 8; i; i--) {
		ret <<= 1;
		if (SPI_PIN & SPI_MISO) {
			ret |= 1;
		}
		SPI_PORT |= SPI_SCK;
		asm volatile("nop");
		asm volatile("nop");
		asm volatile("nop");
		asm volatile("nop");
		asm volatile("nop");
		asm volatile("nop");
		asm volatile("nop");
		asm volatile("nop");
		SPI_PORT &= ~SPI_SCK;
		asm volatile("nop");
		asm volatile("nop");
		asm volatile("nop");
		asm volatile("nop");
		asm volatile("nop");
		asm volatile("nop");
		asm volatile("nop");
		asm volatile("nop");
		asm volatile("nop");
		asm volatile("nop");
		asm volatile("nop");
		asm volatile("nop");
	}
	return ret;
#else
	SPDR = 0xFF;
	loop_until_bit_is_set(SPSR, SPIF);
	return SPDR;
#endif
}

#if EMULATE_SPI
void xmit_spi(BYTE dat)
{
	uint8_t i;
	for (i = 8; i; i--) {
		if (dat & 0x80) {
			SPI_PORT |= SPI_MOSI;
		} else {
			SPI_PORT &= ~SPI_MOSI;
		}
		SPI_PORT |= SPI_SCK;
		asm volatile("nop");
		asm volatile("nop");
		asm volatile("nop");
		asm volatile("nop");
		asm volatile("nop");
		asm volatile("nop");
		asm volatile("nop");
		asm volatile("nop");
		asm volatile("nop");
		asm volatile("nop");
		SPI_PORT &= ~SPI_SCK;
		asm volatile("nop");
		asm volatile("nop");
		asm volatile("nop");
		asm volatile("nop");
		asm volatile("nop");
		asm volatile("nop");
		asm volatile("nop");
		asm volatile("nop");
		asm volatile("nop");
		asm volatile("nop");
		asm volatile("nop");
		dat <<= 1;
	}
}
#endif

BYTE sample_mmc_switches(void)
{
	return 0;
}

