/* vim: set encoding=cp1251 : */
#ifndef MMC_HARDWARE_H
#define MMC_HARDWARE_H

#include "integer.h"



#ifdef _AVR_IOM128_H_

#define SPI_PORT PORTE
#define SPI_PIN PINE
#define SPI_DDR DDRE
#define SPI_SS		(1 << 3)

#define SPI_MOSI	(1 << 2)
#define SPI_MISO	(1 << 0)
#define SPI_SCK		(1 << 1)

#define EMULATE_SPI 1

#else /* ATMega32 */

#define SPI_PORT PORTB
#define SPI_PIN PINB
#define SPI_DDR DDRB
#define SPI_SS		(1 << 4)

#define SPI_MOSI	(1 << 5)
#define SPI_MISO	(1 << 6)
#define SPI_SCK		(1 << 7)

#define EMULATE_SPI 0

#endif

/* }}} */

#if EMULATE_SPI

#define rcvr_spi_m(dst) {*dst = rcvr_spi();}
void xmit_spi(BYTE dat);

#else

#define xmit_spi(dat) 	{ SPDR=(dat); loop_until_bit_is_set(SPSR,SPIF); }
#define rcvr_spi_m(dst)	{ SPDR=0xFF; loop_until_bit_is_set(SPSR,SPIF); *(dst)=SPDR; }

#endif

BYTE rcvr_spi (void);
void mmc_on(void);
void mmc_off(void);
BYTE mmc_is_on(void);
BYTE sample_mmc_switches(void);

#define MMC_SELECT()	{SPI_PORT &= ~SPI_SS; PORTC &= ~1; }
#define	MMC_DESELECT()	{PORTB |= SPI_SS; PORTC |= 1;}

#define SOCKPORT	PINB			/* Socket contact port */
#define SOCKWP		0x20			/* Write protect switch (PB5) */
#define SOCKINS		0x10			/* Card detect switch (PB4) */

/*
	pv = SOCKPORT & (SOCKWP | SOCKINS);	// Sample socket switch 
*/

#endif

