#ifndef I2C_H
#define I2C_H

#include <stdint.h>

#define I2C_SLAVE

#define I2C_E_OK		0
#define I2C_E_ARB		1
#define I2C_E_ADDR_NACK	2
#define I2C_E_DATA_NACK	3
#define I2C_E_BUS		4
#define I2C_E_BUFSIZE	5


typedef void (*i2cRXHandler)(void);
typedef void (*i2cRequestHandler)(void);

void i2c_init(void);
void i2c_init_slave(uint8_t addr);
void i2c_onRX(i2cRXHandler callback);
void i2c_onRequest(i2cRequestHandler callback);
void i2c_setSlaveBuf(uint8_t* buf, uint8_t size);
void i2c_setMasterBuf(uint8_t* buf, uint8_t size);
uint8_t i2c_receive(void);
uint8_t i2c_available(void);
void i2c_send(uint8_t data);
void i2c_startTransmission(void);
uint8_t i2c_endTransmission(uint8_t addr);

#endif

