#include <avr/io.h>
#include <avr/pgmspace.h>
#include "wav.h"

prog_char pat_RIFF[] = "RIFF";
prog_char pat_WAVE[] = "WAVE";
prog_char pat_FMT[] = "fmt ";


static uint8_t strncmp_f(uint8_t *buf, char *pattern, uint8_t n)
{
	uint8_t i;
	for (i = 0; i < n; i++) {
		if (*buf != pgm_read_byte(pattern)) return 1;
		buf++;
		pattern++;
	}
	return 0;
}

uint8_t parse_wav_header(WAVHeader* header)
{
	uint32_t tmp;
	if (strncmp_f(header->riff.id, pat_RIFF, 4)) return 0;
	if (strncmp_f(header->riff.riff_type, pat_WAVE, 4)) return 0;
	if (strncmp_f(header->format.id, pat_FMT, 4)) return 0;
	if (header->format.chunk_size != 0x10) return 0;
	uint8_t nchannels = header->format.channels;
	if (nchannels != 1 && nchannels != 2) return 0;
	tmp = header->format.sample_rate;
	if (tmp < (F_CPU / 64000) || tmp > (F_CPU / 160)) return 0;
	wav_period = F_CPU / tmp;
	tmp = header->format.bytes_per_sample;
	if (nchannels != tmp && nchannels*2 != tmp ) return 0;
	return 1;
}

