#ifndef WAV_H
#define WAV_H

#include <stdint.h>
#include "tff.h"

typedef struct {
	uint8_t id[4];
	uint32_t chunk_size;
	uint8_t riff_type[4];
} RIFFHeader;

typedef struct {
	uint8_t id[4];
	uint32_t chunk_size;
	uint16_t compression;
	uint16_t channels;
	uint32_t sample_rate;
	uint32_t bytes_per_second;
	uint16_t bytes_per_sample;
	uint16_t bits_per_sample;
} FMTHeader;

typedef struct {
	uint8_t id[4];
	uint32_t chunk_size;
} DATAHeader;

typedef struct {
	RIFFHeader riff;
	FMTHeader format;
	DATAHeader data;
} WAVHeader;

typedef union {
	uint8_t buf[1024];
	WAVHeader header;
} WAVBuffer;

uint16_t wav_period;
WAVBuffer wav_buf;
volatile uint16_t wav_bufpos;

uint8_t parse_wav_header(WAVHeader*);

FIL file;

#endif

